/*
Dozen Days of Words episode 4: GrowingWords
Copyright (c) 2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.dozendays.words.growing
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	public class GrowingList
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public const WORDS_PER_LEVEL:int = 25;
		private const WORD_HEIGHT:int = 16;
		private const WORD_WIDTH:int = 150;
		private const WORD_FONT_SIZE:int = 14;
		private const WORD_COLOR:uint = 0xFFFFC0;
		private const WORD_BACKGROUND_COLOR:uint = 0x404010;
		private const WORD_LISTS:Array = new Array(
			// level 1
			new Array ("ACT", "AIR", "ANT", "APE", 
					"BAT", "BID", "BOW", "BUS",
					"CAB", "CAR", "CAT", "COP", "COW", "CUP",
					"DOG", "DAY","DIE","DUO","DYE",
					"EAT", "EAR","END","ERA","EYE",
					"FAT", 
					"GIT", "HAT",
					"ICE", "JOB", "KIT", "LAB", "MOB", "NOT", "OWL", "PIT", 
					"QUE", "RAT", "SIT", "TOP", "USE", "VAT", "WAG", "YAC", 
					"ZEN","FEN","FIT","FOG","FLY",
					"GAG","GYM",
					"HAY","HER","HIM","HOT",
					"ICE","INK","IRE","IVY","JAB","KEY",
					"LAG","LAP","LOG","LYE",
					"MAN","MAT","MAX","NAP","NOD",
					"ODD","OIL","ORE",
					"PAD","PEN","PEW","PIE",
					"RED","RUN","SEW","SIN","SUN",
					"TAX","TIE","TOP","VET"
					),
			// level 2
			new Array("ACRE", "AERY", "AMOK", "ANKH",
					"BELL", "BITE", "BRAT", "BUZZ",
					"CAKE", "CAMP", "CAVE", "CHEW", "CLAP", "CODE", "CYAN",
					"DAMP","DIET","DIRE","DOOM","DOWN",
					"EDIT","ETCH","EVEN","EVIL",
					"FALL","FAME","FAST","FATE","FIRE",
					"GOLD","GLUT",
					"HALL","HEAT","HELP","HINT","HOST",
					"INCH","IRON","JADE","KICK","KING",
					"LACE","LADY","LAMB","LION","LYNX",
					"MALT","MARE","MIND","MYST","NAVY","NEST",
					"OMEN","PALM","PARK","PLAY","PLUS","PONY",
					"QUIT","QUIZ","RAGE","RAZE","REST","RIFT","RING",
					"SHOW","SIZE","SOCK","STAR",
					"TIRE","TUNA",
					"VEIL","VEST","VIEW",
					"WANE","WARP","WHIP","WISH"
					),
			// level 3
			new Array("ABBEY", "ACORN", "ALIAS", "ALPHA", "ANVIL",
					"BERRY", "BLACK", "BROWN", "BUNCH",
					"CANON", "CARVE", "CHAIN", "CHAOS",
					"DECAL","DEVIL","DRAFT","DRESS","DRUNK",
					"ELBOW","EMPTY","ENEMY","ENTER","EXTRA",
					"FABLE","FEIGN","FLAME","FLOAT","FLUID",
					"GIANT","GLAZE","GOOSE","GRAIL","GRAZE",
					"HANDY","HERTZ","HONEY","HORSE","HUMAN",
					"IGLOO","INDEX","ISSUE","IVORY",
					"JUDGE","KNIFE",
					"LEMON","LEVER","LIGHT","LLAMA","LUNGE",
					"MAJOR","MEDIA","MERIT","MONEY",
					"NEXUS","NOISE","NYMPH",
					"OPERA","ORDER",
					"PEACE","PHOTO","PIANO","PLANT","PRISM",
					"QUAKE","RAPID","RHINO","ROYAL",
					"SABRE","SENSE","SEIGE","SLEEP","SOLID","SOUND","SPOON",
					"STORY","STUFF",
					"TABLE","THEME","THINK","TOKEN","TOTEM",
					"ULTRA","UNION","USHER",
					"VERGE","VIXEN",
					"WATER","WHEAT","WRITE"
					),
			// level 4 (6 LETTER WORDS)
			new Array("ABACUS","ACTION", "ADVENT", "ALMOND",
					"BLEARY", "BLAZER", "BRIGHT", "BUSHEL",
					"CENTER", "CHERRY", "CHROME",
					"DEDUCT","DEGREE","DIVINE","DYNAMO","DOUBLE",
					"ELEVEN","EMBLEM","ENCORE","ENGINE",
					"FABRIC","FIGURE","FINGER","FLAVOR","FREEZE",
					"GARDEN","GENTRY","GREASE","GROOVE",
					"HEALTH","HOLLOW","HUBCAP",
					"IMPEND","INBORN","INDIGO","INSIDE",
					"JIGSAW","JUNGLE","KARATE",
					"LEAGUE","LITTLE","LUXURY",
					"MASTER","MATRIX","MENTAL","MILLET","MINUTE","MUTANT",
					"NATURE","NOVICE",
					"OCCULT","ORNATE","OXYGEN",
					"PARROT","PERSON","POLICE","POTION",
					"QUARRY","QUIVER",
					"RABBIT","RELISH","REPAIR",
					"SATIRE","SECOND","STRIKE","SYMBOL",
					"TENANT","THROAT","TRAVEL","TURTLE",
					"VIRTUE","VORTEX",
					"WEEKLY","WILLOW","WONDER","WRAITH"
					),
			// level 5
			new Array("ABANDON", "ACRYLIC", "ALLERGY", "ANTIGEN",
					"BLUBBER", "BONANZA", "BULLDOG", "BURETTE",
					"CAPITAL", "CARCASS", "CARTOON", "CIRCUIT", "COMPLEX", "CYCLONE",
					"DENTIST","DESTROY","DISRUPT","DURABLE",
					"ELASTIC","EPISODE","EXHAUST","EXPLODE",
					"FEARFUL","FLATTEN","FOOLISH","FORSAKE","FRIZZLE",
					"GRAMMAR","GRUMBLE",
					"HAYWIRE","HYDRANT","HYDRATE",
					"IMAGINE","IMITATE","IMPRESS","INFLICT","INSPECT",
					"JOURNEY","JUKEBOX",
					"KETCHUP","KNOWING",
					"LATTICE","LOTTERY",
					"MACHINE","MAGENTA","MEASURE","MISSION",
					"NOSTRIL","NURTURE",
					"OBSCURE","OUTPOST",
					"PATRIOT","PERFECT","PITCHER","PRELUDE","PROTEIN",
					"QUINTET",
					"REAGENT","REFLECT","RELEASE","REVENGE","ROMANCE",
					"SNEAKER","SPECIAL","SPINDLE","SUBJECT","SUSPECT",
					"TERRIFY","TRAFFIC","TRIBUTE","TRUFFLE",
					"UNCLEAN","UNEARTH",
					"VACCINE","VANTAGE",
					"WHITTLE","WORKING"
					)
		);

// ***** VARIABLES **********************************************************

		public var _currentList:Array;
		public var _currentLetterList:Array;

		protected var _words:Array;

// ***** CONSTRUCTOR ********************************************************

		public function GrowingList()
		{
			_currentList = new Array();
			_currentLetterList = new Array();
			_words = new Array();
			var wordFormat:TextFormat = new TextFormat(null, WORD_FONT_SIZE, WORD_COLOR, null, null, null, null, null, TextFormatAlign.CENTER);
			for (var cntr:int = 0; cntr < WORDS_PER_LEVEL; ++cntr) {
				_words[cntr] = new TextField();
				_words[cntr].y = WORD_HEIGHT * cntr;
				_words[cntr].width = WORD_WIDTH;
				_words[cntr].height = WORD_HEIGHT;
				_words[cntr].background = true;
				_words[cntr].backgroundColor = WORD_BACKGROUND_COLOR;
				addChild(_words[cntr]);
			}
		}

// ***** Functions - Puzzle Handling ****************************************

		protected function buildLetterList():void 
		{
			var cntrList:int, cntrLetter:int;
			
			// clear the old data (if any)
			while (_currentLetterList.length > 0) _currentLetterList.pop();
			
			// fill the letter list
			for (cntrList = 0; cntrList < _currentList.length; ++cntrList)
				for (cntrLetter = 0; cntrLetter < _currentList[cntrList].length; ++cntrLetter)
					_currentLetterList.push(_currentList[cntrList].charAt(cntrLetter));

			// this function should never get called with an emply word list, but if it does...
			if (_currentLetterList.length == 0)
				_currentLetterList.push("*"); 
		}
		
		protected function updateDisplay():void
		{
			var cntr:int;
			
			for (cntr = 0; cntr < _currentList.length; ++cntr)
				_words[cntr].text = _currentList[cntr];
			for (cntr = _currentList.length; cntr < WORDS_PER_LEVEL; ++cntr)
				_words[cntr].text = " ";
		}

		public function startLevel(n:int = 1):void
		{
			var levelIndex:int = Math.min(Math.max(n-1, 0), WORD_LISTS.length-1);
			var words:Array = WORD_LISTS[levelIndex];

			// clear the old data (if any)
			while (_currentList.length > 0) _currentList.pop();
			
			// create the list of words for this level
			for (var cntr:int = 0; cntr < WORDS_PER_LEVEL; ++cntr) {
				_currentList.push(words[Math.floor(Math.random()*words.length)]);
			}
			
			buildLetterList();
			updateDisplay();
		}
		
		public function getNextLetter():String
		{
			if (_currentLetterList.length < 1)
				buildLetterList();
			var indx:int = Math.floor(Math.random() * _currentLetterList.length);
			var s:String = _currentLetterList[indx];
			_currentLetterList[indx] = _currentLetterList[_currentLetterList.length-1];
			_currentLetterList.pop();
			return s;
		}
		
		public function getWordLength():int
		{
			return _currentList[0].length;
		}
		
		public function wasWordInList(s:String):Boolean
		{
			var indx:int = -1;
			
			for (var cntr:int = 0; cntr < _currentList.length; ++cntr)
				if (_currentList[cntr] == s)
					indx = cntr;
			
			if (indx < 0)
				return false;
			
			_currentList[indx] = _currentList[_currentList.length - 1];
			_currentList.pop();
			updateDisplay();
			return true;
		}
		
		public function getWordsRemaining():int
		{
			return _currentList.length;
		}
	}
}
